
#include "project.h"
#include "BLEeventhandler.h"
#include <stdio.h>


uint8_t peerbdhandle;

void StackEventHandler(uint32 event, void *eventParam)
{
    
    switch(event)
    {

        case CY_BLE_EVT_STACK_ON:                                       Cy_SCB_UART_PutString(UART_HW, "\r\n CY_BLE_EVT_STACK_ON \r\n");

            Cy_BLE_GAPP_StartAdvertisement(CY_BLE_ADVERTISING_FAST,
                                           CY_BLE_PERIPHERAL_CONFIGURATION_0_INDEX);
        break;
        
        case CY_BLE_EVT_GAPP_ADVERTISEMENT_START_STOP:                  Cy_SCB_UART_PutString(UART_HW, "\r\n CY_BLE_EVT_GAPP_ADVERTISEMENT_START_STOP \r\n");
        break;
        
        case CY_BLE_EVT_GAP_DEVICE_DISCONNECTED:                        Cy_SCB_UART_PutString(UART_HW, "\r\n CY_BLE_EVT_GAP_DEVICE_DISCONNECTED \r\n");
        break;
        
        case CY_BLE_EVT_GAP_DEVICE_CONNECTED:                           Cy_SCB_UART_PutString(UART_HW, "\r\n CY_BLE_EVT_GAP_DEVICE_CONNECTED \r\n");//This event is generated at the GAP Peripheral end after the connection is completed with a peer Central device. The event parameter is a pointer to a structure of type cy_stc_ble_gap_connected_param_t. file:///C:/Program%20Files%20(x86)/Cypress/PDL/3.0.3/doc/ble_api_reference_manual/html/structcy__stc__ble__gap__connected__param__t.html 
            cy_stc_ble_gap_connected_param_t connectionParameter;   
            connectionParameter = *(cy_stc_ble_gap_connected_param_t*) eventParam;
            peerbdhandle = connectionParameter.bdHandle;   
                                                                        printf("\r\n peerbdhandle: %d", peerbdhandle);printf("\r\n TEST");
            Cy_SCB_UART_Put(UART_HW, peerbdhandle);
        break;
        
        case   CY_BLE_EVT_GAP_CONN_ESTB:                                Cy_SCB_UART_PutString(UART_HW, "\r\n CY_BLE_EVT_GAP_CONN_ESTB \r\n"); //This event is triggered on completion of connection establishment. Event parameter is (cy_stc_ble_conn_estb_param_t*) 
        break;

        case   CY_BLE_EVT_GATTC_READ_BY_GROUP_TYPE_RSP:                 Cy_SCB_UART_PutString(UART_HW, "\r\n CY_BLE_EVT_GATTC_READ_BY_GROUP_TYPE_RSP \r\n");
        break;

        case   CY_BLE_EVT_GATTC_READ_BY_TYPE_RSP:                       Cy_SCB_UART_PutString(UART_HW, "\r\n CY_BLE_EVT_GATTC_READ_BY_TYPE_RSP \r\n");
        break;

        case   CY_BLE_EVT_GATTS_WRITE_REQ:                              Cy_SCB_UART_PutString(UART_HW, "\r\n CY_BLE_EVT_GATTS_WRITE_REQ \r\n");
        break;

        case   CY_BLE_EVT_GATTS_WRITE_CMD_REQ:                          Cy_SCB_UART_PutString(UART_HW, "\r\n CY_BLE_EVT_GATTS_WRITE_CMD_REQ \r\n");
        break;

        case   CY_BLE_EVT_GATTS_HANDLE_VALUE_CNF:                       Cy_SCB_UART_PutString(UART_HW, "\r\n CY_BLE_EVT_GATTS_HANDLE_VALUE_CNF \r\n");
        break;

        case   CY_BLE_EVT_GATT_DISCONNECT_IND:                          Cy_SCB_UART_PutString(UART_HW, "\r\n CY_BLE_EVT_GATT_DISCONNECT_IND \r\n");
        break;
        
        case CY_BLE_EVT_GATT_CONNECT_IND :                              Cy_SCB_UART_PutString(UART_HW, "\r\n CY_BLE_EVT_GATT_CONNECT_IND \r\n"); //This event is generated at the GAP Peripheral end after a connection is completed with a peer Central device. The event parameter is a pointer to a structure of type cy_stc_ble_conn_handle_t. 
            cy_stc_ble_conn_handle_t connectionIndParameter;
            connectionIndParameter = *(cy_stc_ble_conn_handle_t*) eventParam;
        
            printf("connectionIndParameter: %x", connectionIndParameter.bdHandle);
        break;
            
            
        case CY_BLE_EVT_GATTS_READ_CHAR_VAL_ACCESS_REQ:                 Cy_SCB_UART_PutString(UART_HW, "\r\n CY_BLE_EVT_GATTS_READ_CHAR_VAL_ACCESS_REQ \r\n");// event is triggered on the GATT Server side when the GATT Client sends a read request. event parameter is of 'cy_stc_ble_gatts_char_val_read_req_t' type.
        break;
        
        case CY_BLE_EVT_TIMEOUT:                                        Cy_SCB_UART_PutString(UART_HW, "\r\n CY_BLE_EVT_TIMEOUT \r\n");
            Cy_BLE_GAPP_StartAdvertisement(CY_BLE_ADVERTISING_FAST,            /* Start the BLE fast advertisement. */
                                           CY_BLE_PERIPHERAL_CONFIGURATION_0_INDEX);
        
        
            
        break;
        default:
        break;
    }
}

